// *** THAT'S MEGAPOV CODE ***
#version unofficial MegaPov 0.5;

#declare r_brick=seed(937);
// *** azulejos ***
#declare t_azulejo=
texture{
 pigment{White*.8+Tan*.2}
 finish{Shiny
  reflection_type 0
  reflection_max .2
  reflection_min .1
  reflection_exponent .9
 }
 normal{bumps scale .5 translate 100*rand(r_brick)}
}
#declare bw=7.5;
#declare num_c=int(120/bw);
#declare num_r=int(45/bw);
#declare cnt_r=0;
#declare azulejos=
union{
#while (cnt_r<num_r)
 #declare cnt_c=0;
 #while (cnt_c<num_c)
  superellipsoid{<.1,.1>
   rotate 90*x
   scale .49
   texture{t_azulejo}
   scale <bw,bw,.5>
   rotate (-.1+.2*rand(r_brick))*x
   rotate (-.1+.2*rand(r_brick))*y
   translate <bw*cnt_c,bw*cnt_r,0>
  }
  #declare cnt_c=cnt_c+1;
 #end
 #declare cnt_r=cnt_r+1;
#end
}
// *** azulejos con agujero ***
#declare bw=7.5;
#declare num_c=int(120/bw);
#declare num_r=int(45/bw);
#declare cnt_r=0;
#declare azulejos_2=
union{
#while (cnt_r<num_r)
 #declare cnt_c=0;
 #while (cnt_c<num_c)
  #if ((cnt_r<2) | (cnt_c<6) | (cnt_c>9))
  superellipsoid{<.1,.1>
   rotate 90*x
   scale .49
   texture{t_azulejo}
   scale <bw,bw,.5>
   rotate (-.1+.2*rand(r_brick))*x
   rotate (-.1+.2*rand(r_brick))*y
   translate <bw*cnt_c,bw*cnt_r,0>
  }
  #end
  #declare cnt_c=cnt_c+1;
 #end
 #declare cnt_r=cnt_r+1;
#end
}
// *** LAB TABLE ***
#declare mesa=
union{
 object{azulejos rotate 90*x translate <-60+bw*.5,.8,-45*.5+bw*.5>}
 box{-.5,.5
  scale <120,2,45>
  texture{
   pigment{DarkBrown}
   normal{dents .1 turbulence .1 lambda 4 scale .2}
   finish{Shiny reflection .1}
   rotate 90*x
  }
 }
 box{-.5,.5
  scale <121,2.1,.5>
  texture{t_cromo_pulido}
  translate (-45*.5-.1)*z
 }
 box{-.5,.5
  scale <121,2.1,.5>
  texture{t_cromo_pulido}
  translate (45*.5+.1)*z
 }
 difference{
  box{-.5,.5}
  box{-.5,.5 scale .9 translate -.1*z}
  scale <118,78,43>
  pigment{White}
  finish{Metal}
  translate -78*.5*y
 }
}
// *** FREGADERO ***
#declare lpcil=1.5;
#declare codo_pila=
sphere_sweep{
 b_spline_sphere_sweep
 9
 <0,0,-bw>,.4
 <0,0,-bw*.5>,.4
 <0,0,-bw*.4>,.4
 <bw*.1,0,-bw*.15>,.4
 <bw*.15,0,-bw*.15>,.4
 <bw*.15,0,-bw*.1>,.4
 <bw*.4,0,0>,.4
 <bw*.5,0,0>,.4
 <bw,0,0>,.4
}
#declare borde=
union{
  cylinder{<-bw*lpcil,0,-bw*2>,<bw*lpcil,0,-bw*2>,.4}
  cylinder{<-bw*lpcil,0, bw*2>,<bw*lpcil,0, bw*2>,.4}
  cylinder{<-bw*2,0,-bw*lpcil>,<-bw*2,0, bw*lpcil>,.4}
  cylinder{< bw*2,0,-bw*lpcil>,< bw*2,0, bw*lpcil>,.4}
  object{codo_pila translate <-bw*2,0,bw*2>}
  object{codo_pila rotate 90*y translate <bw*2,0,bw*2>}
  object{codo_pila rotate -90*x translate <-bw*2,0,-bw*2>}
  object{codo_pila rotate 180*y translate <bw*2,0,-bw*2>}
}
#declare pila_fregadero=
union{
 // *** PILA ***
 union{
  difference{
   box{<-.6,-.6,-.6>,<.6,0,.6>}
   intersection{
    superellipsoid{<.2,.2> rotate 90*x scale .5}
    plane{y,-.02 inverse}
   }
   superellipsoid{<.2,.2> rotate 90*x scale .487}
   scale <bw*4,20,bw*4>
   translate .4*y
  }
  object{borde}
  texture{pigment{NavyBlue*.1+White*.9} finish{Shiny reflection .2}}
 }
 // *** GRIFO ***
 union{
  union{
   intersection{
    sphere{0,2}
    plane{y,-1.5 rotate 50*z translate -4*x}
    plane{y,-1.5 rotate -50*z translate 4*x}
    plane{y,-1 inverse}
   }
   superellipsoid{<1,.2> scale <1.2,1.2,.75> rotate <0,90,-50> translate <-2,1.5,0>}
   superellipsoid{<1,.2> scale <1.2,1.2,.75> rotate <0,90,50> translate <2,1.5,0>}
   cone{<0,1,0>,.8,<0,3,0>,.7}
   sphere{0,.8 translate 3*y}
   texture{t_cromo_pulido}
  }
  union{
   superellipsoid{<1,.2> scale <1.2,1.2,.1>
    translate -.4*z
    rotate <0,90,-50>
    texture{pigment{OrangeRed} finish{Phong_Shiny reflection .3}}
    translate <-2,1.5,0>
   }
   superellipsoid{<1,.2> scale <1.2,1.2,.1>
    translate .4*z
    rotate <0,90,50>
    texture{pigment{Blue*.8+Gray20} finish{Phong_Shiny reflection .3}}
    translate <2,1.5,0>
   }
   superellipsoid{<1,.2> scale <.5,.5,.1>
    translate -.7*z
    rotate <0,90,-50>
    texture{pigment{OrangeRed} finish{Phong_Shiny reflection .3}}
    translate <-2,1.5,0>
   }
   superellipsoid{<1,.2> scale <.5,.5,.1>
    translate .7*z
    rotate <0,90,50>
    texture{pigment{Blue*.8+Gray20} finish{Phong_Shiny reflection .3}}
    translate <2,1.5,0>
   }
  }
  union{
   cylinder{<0,0,0>,<0,4,0>,.6}
   intersection{
    torus{3,.6 rotate 90*z}
    plane{y,0 inverse}
    plane{y,0 inverse rotate -20*x}
    translate <0,4,3>
   }
   texture{t_cromo_pulido}
   rotate 15*x
   translate 3*y
  }
  scale 1.5
  translate <0,1.5,-bw*3>
 }
}
// *** LAB TABLE WITH FREGADERO ***
#declare mesa_2=
union{
 object{azulejos_2 rotate 90*x translate <-60+bw*.5,.8,-45*.5+bw*.5>}
 difference{
  box{-.5,.5 scale <120,2,45>}
  box{-.5,.5 scale <bw*4,3,bw*4> translate <0,0,bw*.9>}
  texture{
   pigment{DarkBrown}
   normal{dents .1 turbulence .1 lambda 4 scale .2}
   finish{Shiny reflection .1}
   rotate 90*x
  }
 }
 box{-.5,.5
  scale <121,2.1,.5>
  texture{t_cromo_pulido}
  translate (-45*.5-.1)*z
 }
 box{-.5,.5
  scale <121,2.1,.5>
  texture{t_cromo_pulido}
  translate (45*.5+.1)*z
 }
 object{pila_fregadero
  scale <.8,1,.8>
  translate <0,.8,bw*.9>
 }
}
#declare pata_colgador=
union{
 box{-.5,.5 scale <.4,38,1.5>}
 box{-.5,.5 scale <.4,16,1.5> translate -8*y rotate -18*x translate -8*y}
 box{-.5,.5 scale <.4,16,1.5> translate -8*y rotate  18*x translate -8*y}
 box{-.5,.5 scale <1.5,.4,5> translate (-38*.5+.2)*y}
}
#declare soporte_bancada=
union{
 cylinder{<-60,0,0>,<60,0,0>,.3 translate 12*y}
 cylinder{<-60,0,0>,<60,0,0>,.3 translate 24*y}
 cylinder{<-60,0,0>,<60,0,0>,.3 translate 36*y}
 box{-.5,.5 scale <.4,24,1.5> translate <-24,24*.5+12,0>}
 box{-.5,.5 scale <.4,24,1.5> translate < 24,24*.5+12,0>}
 box{-.5,.5 scale <.4,24,1.5> translate <-48,24*.5+12,0>}
 box{-.5,.5 scale <.4,24,1.5> translate < 48,24*.5+12,0>}
 object{pata_colgador
  translate <-12,38*.5,0>
 }
 object{pata_colgador
  translate <12,38*.5,0>
 }
 object{pata_colgador
  translate <-36,38*.5,0>
 }
 object{pata_colgador
  translate <36,38*.5,0>
 }
 object{pata_colgador
  translate <-60,38*.5,0>
 }
 object{pata_colgador
  translate <60,38*.5,0>
 }
 texture{T_Chrome_2D
  normal{wrinkles .1 scale .1}
 }
}
